net.sf.saxon.type

## Class BuiltInListType

- java.lang.Object
- - net.sf.saxon.type.BuiltInListType

- All Implemented Interfaces:
    Serializable, ListType, SchemaComponent, SchemaType, SimpleType

      public class BuiltInListType
      extends Object
      implements ListType, Serializable

  This class is used to implement the built-in list types NMTOKENS, ENTITIES, IDREFS. It is also used to represent the anonymous type of the xsi:schemaLocation attribute (a list of xs:anyURI values).

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static BuiltInListType` | `ANY_URIS`
    `static BuiltInListType` | `ENTITIES`
    `static BuiltInListType` | `IDREFS`
    `static BuiltInListType` | `NMTOKENS`

    - ### Fields inherited from interface net.sf.saxon.type.SchemaType

      `DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

    - ### Fields inherited from interface net.sf.saxon.type.SchemaComponent

      `COMPONENT_FUNCTION_TYPE, FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BuiltInListType(int fingerprint)` Create a new ListType.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allowsDerivation(int derivation)` Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
    `void` | `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
    `String` | `applyWhitespaceNormalization(String value)` Apply the whitespace normalization rules for this simple type
    `AtomicSequence` | `atomize(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
    `void` | `checkTypeDerivationIsOK(SchemaType type, int block)` Check that this type is validly derived from a given type
    `SchemaType` | `getBaseType()` Returns the base type that this type inherits from.
    `int` | `getBlock()` Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
    `SchemaType` | `getBuiltInBaseType()` Get the built-in type from which this type is derived by restriction
    `FunctionItem` | `getComponentAsFunction()` Get the schema component in the form of a function item.
    `int` | `getDerivationMethod()` Gets the integer code of the derivation method used to derive this type from its parent.
    `String` | `getDescription()` Get a description of this type for use in error messages.
    `String` | `getDisplayName()` Get the display name of the type: that is, a lexical QName with an arbitrary prefix
    `String` | `getEQName()` Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
    `int` | `getFinalProhibitions()` Get the types of derivation that are not permitted, by virtue of the "final" property.
    `int` | `getFingerprint()` Get the fingerprint of the name of this type
    `SimpleType` | `getItemType()` Returns the simpleType of the items in this ListType.
    `SchemaType` | `getKnownBaseType()` Returns the base type that this type inherits from.
    `String` | `getLocalName()` Get the local name of this type
    `String` | `getName()` Get the local name of this type
    `int` | `getNameCode()` Get the namecode of the name of this type.
    `int` | `getRedefinitionLevel()` Get the redefinition level.
    `String` | `getSystemId()` Get the URI of the schema document containing the definition of this type
    `String` | `getTargetNamespace()` Get the target namespace of this type
    `AtomicSequence` | `getTypedValue(CharSequence value, NamespaceResolver resolver, ConversionRules rules)` Get the typed value of a given input string.
    `int` | `getValidationStatus()` Get the validation status - always valid
    `int` | `getWhitespaceAction()` Determine how values of this simple type are whitespace-normalized.
    `boolean` | `isAnonymousType()` Test whether this is an anonymous type
    `boolean` | `isAtomicType()` Test whether this Simple Type is an atomic type
    `boolean` | `isBuiltInType()` Determine whether this is a built-in type or a user-defined type
    `boolean` | `isComplexType()` Test whether this SchemaType is a complex type
    `boolean` | `isExternalType()` Return true if this is an external object type, that is, a Saxon-defined type for external Java or .NET objects
    `boolean` | `isIdRefType()` Ask whether this type is an IDREF or IDREFS type.
    `boolean` | `isIdType()` Ask whether this type is an ID type.
    `boolean` | `isListType()` Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members
    `boolean` | `isNamespaceSensitive()` Test whether this type is namespace sensitive, that is, if a namespace context is needed to translate between the lexical space and the value space.
    `boolean` | `isSameType(SchemaType other)` Test whether this is the same type as another type.
    `boolean` | `isSimpleType()` Test whether this SchemaType is a simple type
    `boolean` | `isUnionType()` Test whether this Simple Type is a union type
    `CharSequence` | `postprocess(CharSequence input)` Reverse any pre-lexical facets, other than whitespace.
    `CharSequence` | `preprocess(CharSequence input)` Apply any pre-lexical facets, other than whitespace.
    `ValidationFailure` | `validateContent(CharSequence value, NamespaceResolver nsResolver, ConversionRules rules)` Check whether a given input string is valid according to this SimpleType

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ENTITIES

          public static BuiltInListType ENTITIES

    - #### IDREFS

          public static BuiltInListType IDREFS

    - #### NMTOKENS

          public static BuiltInListType NMTOKENS

    - #### ANY_URIS

          public static BuiltInListType ANY_URIS

  - ### Constructor Detail

    - #### BuiltInListType

          public BuiltInListType(int fingerprint)

      Create a new ListType.
      Parameters:
        `fingerprint` - identifies the name of the type

  - ### Method Detail

    - #### isExternalType

          public boolean isExternalType()

      Return true if this is an external object type, that is, a Saxon-defined type for external Java or .NET objects
      Specified by:
        `isExternalType` in interface `SimpleType`
      Returns:
        true if this is an external type

    - #### isBuiltInType

          public boolean isBuiltInType()

      Determine whether this is a built-in type or a user-defined type
      Specified by:
        `isBuiltInType` in interface `SimpleType`
      Returns:
        true if this is a built-in type

    - #### getSystemId

          public String getSystemId()

      Get the URI of the schema document containing the definition of this type
      Specified by:
        `getSystemId` in interface `SchemaType`
      Returns:
        null for a built-in type

    - #### getRedefinitionLevel

          public int getRedefinitionLevel()

      Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.
      Specified by:
        `getRedefinitionLevel` in interface `SchemaComponent`
      Returns:
        the redefinition level

    - #### getWhitespaceAction

          public int getWhitespaceAction()

      Determine how values of this simple type are whitespace-normalized.
      Specified by:
        `getWhitespaceAction` in interface `SimpleType`
      Returns:
        one of `Whitespace.PRESERVE`, `Whitespace.COLLAPSE`, `Whitespace.REPLACE`.

    - #### getValidationStatus

          public int getValidationStatus()

      Get the validation status - always valid
      Specified by:
        `getValidationStatus` in interface `SchemaComponent`
      Returns:
        one of the values `SchemaComponent.UNVALIDATED`, `SchemaComponent.VALIDATING`, `SchemaComponent.VALIDATED`, `SchemaComponent.INVALID`, `SchemaComponent.INCOMPLETE`

    - #### getBaseType

          public SchemaType getBaseType()

      Returns the base type that this type inherits from. If this type is a Simpletype that is a built in primitive type then null is returned.
      Specified by:
        `getBaseType` in interface `SchemaType`
      Returns:
        the base type.

    - #### isAtomicType

          public boolean isAtomicType()

      Test whether this Simple Type is an atomic type
      Specified by:
        `isAtomicType` in interface `SchemaType`
      Specified by:
        `isAtomicType` in interface `SimpleType`
      Returns:
        false, this is not an atomic type

    - #### isIdType

          public boolean isIdType()

      Ask whether this type is an ID type. This is defined to be any simple type who typed value may contain atomic values of type xs:ID: that is, it includes types derived from ID by restriction, list, or union. Note that for a node to be treated as an ID, its typed value must be a *single* atomic value of type ID; the type of the node, however, can still allow a list.
      Specified by:
        `isIdType` in interface `SchemaType`
      Returns:
        true if this type is an ID type

    - #### isIdRefType

          public boolean isIdRefType()

      Ask whether this type is an IDREF or IDREFS type. This is defined to be any simple type who typed value may contain atomic values of type xs:IDREF: that is, it includes types derived from IDREF or IDREFS by restriction, list, or union
      Specified by:
        `isIdRefType` in interface `SchemaType`
      Returns:
        true if this type is an IDREF type

    - #### isListType

          public boolean isListType()

      Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members
      Specified by:
        `isListType` in interface `SimpleType`
      Returns:
        true if this is a list type

    - #### isUnionType

          public boolean isUnionType()

      Description copied from interface: `SimpleType`
      Test whether this Simple Type is a union type
      Specified by:
        `isUnionType` in interface `SimpleType`
      Returns:
        true if this is a union type

    - #### isAnonymousType

          public boolean isAnonymousType()

      Test whether this is an anonymous type
      Specified by:
        `isAnonymousType` in interface `SchemaType`
      Returns:
        true if this SchemaType is an anonymous type

    - #### getBuiltInBaseType

          public SchemaType getBuiltInBaseType()

      Description copied from interface: `SimpleType`
      Get the built-in type from which this type is derived by restriction
      Specified by:
        `getBuiltInBaseType` in interface `SimpleType`
      Returns:
        the built-in type from which this type is derived by restriction. This will not necessarily be a primitive type.

    - #### isNamespaceSensitive

          public boolean isNamespaceSensitive()

      Description copied from interface: `SimpleType`
      Test whether this type is namespace sensitive, that is, if a namespace context is needed to translate between the lexical space and the value space. This is true for types derived from, or containing, QNames and NOTATIONs
      Specified by:
        `isNamespaceSensitive` in interface `SimpleType`
      Returns:
        true if the type is namespace-sensitive

    - #### getName

          public String getName()

      Get the local name of this type
      Specified by:
        `getName` in interface `SchemaType`
      Returns:
        the local name of this type definition, if it has one. Return null in the case of an anonymous type.

    - #### getTargetNamespace

          public String getTargetNamespace()

      Get the target namespace of this type
      Specified by:
        `getTargetNamespace` in interface `SchemaType`
      Returns:
        the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

    - #### getEQName

          public String getEQName()

      Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
      Specified by:
        `getEQName` in interface `SchemaType`
      Returns:
        an EQName identifying the type.

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the name of this type
      Specified by:
        `getFingerprint` in interface `SchemaType`
      Returns:
        the fingerprint. Returns an invented fingerprint for an anonymous type.

    - #### getNameCode

          public int getNameCode()

      Get the namecode of the name of this type. Because built-in types don't depend on the namePool, this actually returns the fingerprint, which contains no information about the namespace prefix
      Specified by:
        `getNameCode` in interface `SchemaType`
      Returns:
        the namecode. Returns an invented namecode for an anonymous type.

    - #### getDisplayName

          public String getDisplayName()

      Get the display name of the type: that is, a lexical QName with an arbitrary prefix
      Specified by:
        `getDisplayName` in interface `SchemaType`
      Returns:
        a lexical QName identifying the type

    - #### isComplexType

          public boolean isComplexType()

      Test whether this SchemaType is a complex type
      Specified by:
        `isComplexType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a complex type

    - #### isSimpleType

          public boolean isSimpleType()

      Test whether this SchemaType is a simple type
      Specified by:
        `isSimpleType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a simple type

    - #### getBlock

          public int getBlock()

      Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
      Specified by:
        `getBlock` in interface `SchemaType`
      Returns:
        the value of the 'block' attribute for this type

    - #### getKnownBaseType

          public SchemaType getKnownBaseType()
                                      throws IllegalStateException

      Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.
      Returns:
        the base type.
      Throws:
        `IllegalStateException` - if this type is not valid.

    - #### getDerivationMethod

          public int getDerivationMethod()

      Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.
      Specified by:
        `getDerivationMethod` in interface `SchemaType`
      Returns:
        a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

    - #### allowsDerivation

          public boolean allowsDerivation(int derivation)

      Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
      Specified by:
        `allowsDerivation` in interface `SchemaType`
      Parameters:
        `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
      Returns:
        true if this kind of derivation is allowed

    - #### getFinalProhibitions

          public int getFinalProhibitions()

      Get the types of derivation that are not permitted, by virtue of the "final" property.
      Specified by:
        `getFinalProhibitions` in interface `SchemaType`
      Returns:
        the types of derivation that are not permitted, as a bit-significant integer containing bits such as `SchemaType.DERIVATION_EXTENSION`

    - #### getComponentAsFunction

          public FunctionItem getComponentAsFunction()

      Get the schema component in the form of a function item. This allows schema information to be made visible to XSLT or XQuery code. The function makes available the contents of the schema component as defined in the XSD specification. The function takes a string as argument representing a property name, and returns the corresponding property of the schema component. There is also a property "class" which returns the kind of schema component, for example "Attribute Declaration".
      Specified by:
        `getComponentAsFunction` in interface `SchemaComponent`
      Returns:
        the schema component represented as a function from property names to property values.

    - #### atomize

          public AtomicSequence atomize(NodeInfo node)
                                 throws XPathException

      Get the typed value of a node that is annotated with this schema type. The result of this method will always be consistent with the method
      Specified by:
        `atomize` in interface `SchemaType`
      Parameters:
        `node` - the node whose typed value is required
      Returns:
        the typed value.
      Throws:
        `XPathException` - if the node cannot be atomized, for example if this is a complex type with element-only content
      Since:
        8.5

    - #### isSameType

          public boolean isSameType(SchemaType other)

      Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)
      Specified by:
        `isSameType` in interface `SchemaType`
      Parameters:
        `other` - the other type
      Returns:
        true if this is the same type as other

    - #### getDescription

          public String getDescription()

      Description copied from interface: `SchemaType`
      Get a description of this type for use in error messages. This is the same as the display name in the case of named types; for anonymous types it identifies the type by its position in a source schema document.
      Specified by:
        `getDescription` in interface `SchemaType`
      Returns:
        text identifing the type, for use in a phrase such as "the type XXXX".

    - #### checkTypeDerivationIsOK

          public void checkTypeDerivationIsOK(SchemaType type,
                                     int block)
                                       throws SchemaException

      Check that this type is validly derived from a given type
      Specified by:
        `checkTypeDerivationIsOK` in interface `SchemaType`
      Parameters:
        `type` - the type from which this type is derived
        `block` - the derivations that are blocked by the relevant element declaration
      Throws:
        `SchemaException` - if the derivation is not allowed

    - #### getLocalName

          public String getLocalName()

      Get the local name of this type
      Returns:
        the local part of the name, or null if the type is anonymous

    - #### getItemType

          public SimpleType getItemType()

      Returns the simpleType of the items in this ListType.
      Specified by:
        `getItemType` in interface `ListType`
      Returns:
        the simpleType of the items in this ListType.

    - #### applyWhitespaceNormalization

          public String applyWhitespaceNormalization(String value)

      Apply the whitespace normalization rules for this simple type
      Parameters:
        `value` - the string before whitespace normalization
      Returns:
        the string after whitespace normalization

    - #### analyzeContentExpression

          public void analyzeContentExpression(Expression expression,
                                      int kind,
                                      StaticContext env)
                                        throws XPathException

      Analyze an expression to see whether the expression is capable of delivering a value of this type.
      Specified by:
        `analyzeContentExpression` in interface `SchemaType`
      Parameters:
        `expression` - the expression that delivers the content
        `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
        `env` - the XPath static context
      Throws:
        `XPathException` - if the expression will never deliver a value of the correct type

    - #### validateContent

          public ValidationFailure validateContent(CharSequence value,
                                          NamespaceResolver nsResolver,
                                          ConversionRules rules)

      Check whether a given input string is valid according to this SimpleType
      Specified by:
        `validateContent` in interface `SimpleType`
      Parameters:
        `value` - the input string to be checked
        `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
        `rules` - the conversion rules for this configuration
      Returns:
        either null to indicate that validation succeeded, or a ValidationFailure object giving information about why it failed
      Throws:
        `UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

    - #### getTypedValue

          public AtomicSequence getTypedValue(CharSequence value,
                                     NamespaceResolver resolver,
                                     ConversionRules rules)
                                       throws ValidationException

      Get the typed value of a given input string. This method assumes that the input value is valid according to this SimpleType
      Specified by:
        `getTypedValue` in interface `SimpleType`
      Parameters:
        `value` - the string whose typed value is required
        `resolver` - namespace resolver for namespace-sensitive content
        `rules` -
      Returns:
        an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`, The next() method on the iterator throws no checked exceptions, although it is not actually declared as an UnfailingIterator.
      Throws:
        `ValidationException` - if the supplied value is not in the lexical space of the data type

    - #### preprocess

          public CharSequence preprocess(CharSequence input)

      Apply any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess
      Specified by:
        `preprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be preprocessed
      Returns:
        the value after preprocessing

    - #### postprocess

          public CharSequence postprocess(CharSequence input)
                                   throws ValidationException

      Reverse any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess. This is called when converting a value of this type to a string
      Specified by:
        `postprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be postprocessed: this is the "ordinary" result of converting the value to a string
      Returns:
        the value after postprocessing
      Throws:
        `ValidationException` - if postprocessing detects that the value is invalid

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.